<?php

namespace FiloBlu\ExtAmastyGeoipRedirect\Model;

class CountryContinent extends \Magento\Framework\Model\AbstractModel {
    
    protected $_countryContinentCollectionFactory;
    
    protected $_continent;
    
    public function __construct(
        \FiloBlu\ExtAmastyGeoipRedirect\Model\ResourceModel\CountryContinent\CollectionFactory $countryContinentCollectionFactory,
        \FiloBlu\ExtAmastyGeoipRedirect\Model\Continent $continent,
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        array $data = []
    )
    {
        $this->_countryContinentCollectionFactory = $countryContinentCollectionFactory;
        $this->_continent = $continent;
        parent::__construct($context, $registry, $resource, $resourceCollection, $data);
    }
    
     /**
     * Initialize resource model
     *
     * @return void
     */
    protected function _construct() {
        $this->_init('FiloBlu\ExtAmastyGeoipRedirect\Model\ResourceModel\CountryContinent');
    }
    
    public function getContinentByCountry($countryId)
    {
        $collection = $this->_countryContinentCollectionFactory->create();
        $collection->addFieldToSelect(array('continent_id'));
        $collection->addFieldToFilter('country_id', ["eq" => $countryId]);
        
        return $this->_continent->getContinentById($collection->getFirstItem()->getContinentId());
    }

}
